#include "OUDLEException.h"

OUDLEException::OUDLEException (string fileName, int lineNum, int errCode, string exceptMsg)
{
	SetFileName(fileName);
	SetLineNum(lineNum);
	SetErrorCode(errCode);
	SetExceptionMsg(exceptMsg);
}

string OUDLEException::GetFileName()
{
	return FileName;
}

int OUDLEException::GetLineNum()
{
	return LineNum;
}

int OUDLEException::GetErrorCode()
{
	return ErrCode;
}

string OUDLEException::GetErrorString()
{
	return string("");
}

string OUDLEException::GetExceptionMsg()
{
	return ExceptionMsg;
}

string OUDLEException::GetFormatedExceptionMessage()
{
	char tmpInt[20] = {0};
	string s;
	s += "Error Code (0x";
	sprintf(tmpInt, "%x", ErrCode);
	s += tmpInt;
	s += ") in ";
	s += FileName + " (";
	sprintf(tmpInt, "%d", LineNum);
	s += tmpInt;
	s += "): ";
	s += ExceptionMsg;

	return s;
}

void OUDLEException::SetFileName(string s)
{
	FileName = s;
	return;
}

void OUDLEException::SetLineNum(int ln)
{
	LineNum = ln;
	return;
}

void OUDLEException::SetErrorCode(int c)
{
	ErrCode = c;
	return;
}

void OUDLEException::SetExceptionMsg(string s)
{
	ExceptionMsg = s;
	return;
}


//*************** class IOException ***************//

// constructor
IOException::IOException (string fileName, int lineNum, int errCode, string exceptMsg) :
		OUDLEException (fileName, lineNum, errCode, exceptMsg)
{

}


//*************** class InvalidFormatException ***************//

// constructor
InvalidFormatException::InvalidFormatException (string fileName, int lineNum, int errCode, string exceptMsg) :
		OUDLEException (fileName, lineNum, errCode, exceptMsg)
{

}


//*************** class MemoryAllocationException ***************//

// constructor
MemoryAllocationException::MemoryAllocationException (string fileName, int lineNum, int errCode, string exceptMsg) :
		OUDLEException (fileName, lineNum, errCode, exceptMsg)
{

}


//*************** class OutOfBoundException ***************//

// constructor
OutOfBoundException::OutOfBoundException (string fileName, int lineNum, int errCode, string exceptMsg) :
		OUDLEException (fileName, lineNum, errCode, exceptMsg)
{

}


