#ifndef FSM_H
#define FSM_H

#include <vector>
using namespace std;

#include "Utility.h"
#include "CharSetMap.h"

#define NON_FINAL 0xFFFF

struct POccurrence {
	int location;
	Word patternID;
};

// class implements Finite State Machine, containing multiple patterns
// that are parallelly matched in a given string
class FSM {
	Word alphabetSize;	// num of allowed chars in curr FSM
	vector <Word*> table;
	vector <Word> finalStatus;

	CharSetMap charSetMap;
	bool bInit;
public:
	FSM ();
	FSM (const FSM&);
	~FSM ();
	bool allocFSM (vector <wstring> patterns);
	void deAllocFSM ();
	POccurrence find (wstring text, unsigned int sIndex);
	bool findWhole (wstring text);
	bool isDefined () { return bInit; }
};

#endif
